 /*  RpiDATV_Arduino V1.0
  *   By Alain Fort F1CJN August 30, 2015
      RpiDATV is written by Evariste, F5OEO
      Arduino interface ro RpiDATV is written by Alain, F1CJN
     
    Pilotage du programme RpiDATV via un port série à 9600 bauds
    Serial port Arduino RX at A4(18) to Rpi Tx (pin 8) and Arduino TX at A5(19) (not directly)to Rpi RX (pin 10)
    but using a resistor voltage divider(5volt to 3.3 volt
    
 *** I am not responsible for any GPIO burned if not using the resistive divider !!***
 *** Je décline tout responsabilité de tout GPIO cassé par non respect du diviseur résistif"
 
  The circuit uses the Arduino LCD keypad shield found on Ebay for less than 4 Euros
  
  LCD RS pin to digital pin 8  
  LCD Enable pin to digital pin 9
  LCD D4 pin to digital pin 4
  LCD D5 pin to digital pin 5
  LCD D6 pin to digital pin 6
  LCD D7 pin to digital pin 7
  LCD R/W pin to ground
  LCD Backlight to  pin 10

  Arduino +5V connected to Raspberry pin 2  (If you need to use the Arduino USB port do not connect to pin 2)
  Arduino port série RX pin A4 to Raspberry pin TX 8
  Arduino port série TX pin A5 (see below)not directly to Raspberry pin 10 RX 
  Arduino GND to Raspberry GND (pin6)
  
            *****************Très IMPORTANT ********************
  Utiliser un diviseur de tension sur la sortie Arduino TX (A5) vers le Raspberry  (A5 vers 470 Ohm puis 910 Ohm au ground), 
  Tx du Rpi est le point commun, ce qui limite la tension TX voltage à 3.3 volt. 
     Arduino A5 TX  ----[__470__]------ Rpi 10 RX --------[__910__]-----GND
 *** Je décline tout responsabilité de tout GPIO cassé par non respect du diviseur résistif"***
 * 
 * Si vous souhaitez utiliser le port USB de l'Arduino, ne pas connecter le +5V Arduino à la pin 2 du Raspberry *** 
 
            ******** Modification d'un fichier RpiDATV  *********
  1) Télecharger WinSCP sur Internet
  2) Connecter le Rasberry a votre reseau Ethernet
  3) lancer WinSCP,se connecter (pi et mot de passe:tv), mettre protocole en "SCP",
     aller dans avancé Environnement, Shell/SCP et mettre Shell à "Sudo su -"
  4)aller dans le répertoire /etc
     et ouvrir le fichier "inittab"
  5) modifier la dernière ligne du fichier inittab suivant :
      T0:23:respawn:/sbin/getty -L ttyAMA0 9600 vt100
  6) enregistrer le fichier inittab et redemarrer le Raspberry 
  
  Les touches LEFT,RIGHT,UP et DOWN permettent de modifier les paramètres
  Les paramètres sont envoyés au Raspberry par un appui court sur la touche SELECT
  EEPROM enregistrée par le bouton SELECT par un appui long (1 seconde environ)
  EEPROM est lue à la mise sous tension et les anciens paramètres sont actifs.


            ***************VERY IMPORTANT ************************
  It uses a voltage divider to Raspberry  (A5 to 470 Ohm then 910 Ohm to gnd), 
  Tx to Rpi is the center point, for limiting the TX voltage to 3.3 volt. 
  Arduino A5 TX  ----[__470__]------ Rpi 10 RX --------[__910__]-----GND
  *** I am not responsible for any GPIO burned if not using the resistive divider !!***
  * 
  *  If you need to use the Arduino USB port to modify and test, do no connect the Arduino +5V to Raspberry pin 2 

             ********* Modification of a RpiDATV file ****************
  1) Download WinSCP on Internet
  2) Connect the Rasberry to your private Ethernet network
  3) Start WinSCP, connection (pi et psw:tv),set protocol with "SCP",
    and set Environnment/SCP  Shell with "sudo su-" 
  4) Go to the /etc and open the "inittab" file
  5) Modifiy the last line of the inittab file :
      T0:23:respawn:/sbin/getty -L ttyAMA0 9600 vt100
  6) Write the inittab file and restart the Raspberry 
  
  Touches LEFT,RIGHT,UP and DOWN are used to modify the parameters 
  Parameters are send to the Raspberry when SELECT button is pushed
  Parameters are written into EEPROM if SELECT button is pushed during more than 1 second
  EEPROM values are send to Rpi when the programm starts
 */
  
#include <LiquidCrystal.h>
#include <SoftwareSerial.h>
#include <EEPROM.h>

SoftwareSerial RpiSerial(18,19); // A4,A5 analogique ~ RX,TX
LiquidCrystal lcd(8,9,4,5,6,7);

byte poscursor=0; //position curseur courante 0 à 15
byte line=0;  // ligne afficheur LCD en cours 0 ou 1
byte page; // page LCD en cours
byte login;
byte ip; byte op;byte rw;
byte fec;byte oldfec;

int sr; int oldsr;
int pidv;int oldpidv;
int freq; int oldfreq; int freq1;
int loop1;int oldloop1;
int MAX_CMD_LENGTH =40 ;
int cmdIndex;
int lcd_key     = 0;
int adc_key_in  = 0;
int timer=0; // utilisé pour mesurer la durée d'appui sur une touche
unsigned int i = 0;

char cmd[64];
char incomingByte;

char* ipStrings[]={"CAMH264", "CAMMPEG-2","FILETS",
"PATERNAUDIO", "CARRIER","TESTMODE","IPTSIN"};
char* opStrings[]={"IQ", "QPSKRF","BATC",
"DIGITHIN", "DTX1","DATVEXPRESS"};

#define btnRIGHT  0
#define btnUP     1
#define btnDOWN   2
#define btnLEFT   3
#define btnSELECT 4
#define btnNONE   5

//****************************SP LECTURE BOUTONS************************************************
int read_LCD_buttons()
{
 adc_key_in = analogRead(0);      // read the value from the buttons
 if (adc_key_in < 50)   return btnRIGHT;  
 if (adc_key_in < 195)  return btnUP; 
 if (adc_key_in < 380)  return btnDOWN; 
 if (adc_key_in < 555)  return btnLEFT; 
 if (adc_key_in < 790)  return btnSELECT;   
 return btnNONE;  // Relachement de la touche
}

void initRpi ()
      {
      RpiSerial.print ("set_config_var()\r");
      RpiSerial.print ("{\r");
      RpiSerial.print ("lua - \"$1\" \"$2\" \"$3\" <<EOF > \"$3.bak2\" \r");
      RpiSerial.print ("local key=assert(arg[1])\r");
      RpiSerial.print ("local value=assert(arg[2])\r");
      RpiSerial.print ("local fn=assert(arg[3])\r");
      RpiSerial.print ("local file=assert(io.open(fn))\r");
      RpiSerial.print ("local made_change=false\r");
      RpiSerial.print ("for line in file:lines() do\r");
      RpiSerial.print ("if line:match(\"^#?%s*\"..key..\"=.*$\") then\r");
      RpiSerial.print ("line=key..\"=\"..value\r");
      RpiSerial.print ("made_change=true\r");
      RpiSerial.print ("end\r"); 
      RpiSerial.print ("print(line)\r"); 
      RpiSerial.print ("end\r");
      RpiSerial.print ("if not made_change then\r");
      RpiSerial.print ("print(key..\"=\"..value)\r"); 
      RpiSerial.print ("end\r");  
      RpiSerial.print ("EOF\r");
      RpiSerial.print ("mv \"$3.bak2\" \"$3\"\r");  
      RpiSerial.print ("}\r"); 
      }

void send2Rpi () // write each parameter into rpidatvconfig.txt
      {
      RpiSerial.print ("set_config_var symbolrate "); 
      RpiSerial.print(sr,DEC);
      RpiSerial.print (" rpidatvconfig.txt\r"); 
      //Serial.print(sr,DEC); 

      RpiSerial.print ("set_config_var fec "); 
      RpiSerial.print(fec,DEC);
      RpiSerial.print (" rpidatvconfig.txt\r"); 
      //Serial.print(fec,DEC); 

      RpiSerial.print ("set_config_var freqoutput "); 
      RpiSerial.print(freq/10,DEC);
      RpiSerial.print(".");
      RpiSerial.print(freq1,DEC);
      RpiSerial.print (" rpidatvconfig.txt\r"); 

      RpiSerial.print ("set_config_var pidvideo "); 
      RpiSerial.print(pidv,DEC);
      RpiSerial.print (" rpidatvconfig.txt\r"); 
      //Serial.print(pidv,DEC); 

      RpiSerial.print ("set_config_var modeinput "); 
      RpiSerial.print(ipStrings[ip]);
      RpiSerial.print (" rpidatvconfig.txt\r"); 
      //Serial.print(ip,DEC); 

      RpiSerial.print ("set_config_var modeoutput "); 
      RpiSerial.print(opStrings[op]);
      RpiSerial.print (" rpidatvconfig.txt\r"); 
      //Serial.print(op,DEC);     
    }
    
void printfreq ()
{
  lcd.setCursor(0,0);
  lcd.print("F=");
  if (freq<10000) lcd.print(" ");
  if (freq<1000)  lcd.print(" ");
  lcd.print(freq/10,DEC);lcd.print(".");
  freq1=freq-((freq/10)*10);
  lcd.print(freq1);
}

void printsr()
{
  lcd.setCursor(8,0);  lcd.print(" SR="); 
  if (sr<1000) lcd.print(" ");
  lcd.print(sr,DEC);
}

void printpidv()
{  
  lcd.setCursor(5,1);  lcd.print("  PIDV=");
  lcd.setCursor(12,1);
  if (pidv<1000)lcd.print(" ");
  lcd.print(pidv,DEC);
}

void printmemo ()
{
  lcd.setCursor(0,0); lcd.print("  MEMORIZATION  "); 
  lcd.setCursor(0,1); lcd.print("  INTO EEPROM   ");  
}

void printall ()
{
  printfreq();  
  printsr();  
  lcd.setCursor(0,1); lcd.print("FEC=");lcd.print(fec,DEC); 
  printpidv();
  lcd.blink();
}

void printipop ()
{
  lcd.setCursor(0,0); lcd.print("IP=");lcd.print("             "); 
  lcd.setCursor(3,0);lcd.print (ipStrings[ip]);
  lcd.setCursor(0,1);lcd.print("OP=");lcd.print("             "); 
  lcd.setCursor(3,1); lcd.print (opStrings[op]);
  lcd.setCursor(poscursor,line);
  lcd.blink();
}

void loginRpi()
{
     RpiSerial.print ("pi\r");
     delay(100);
     RpiSerial.print ("tv\r");
     delay(100);
     RpiSerial.print("cd Rpi*\r");
     Serial.print ("Login en cours\r\n");// pour le test 
}


void eewrite() //ecriture EEPROM  EEPROM.write(adr,data);
{   
 //découpage de la variable val qui contient la valeur à sauvegarder en mémoire
 //   unsigned char fort = (freq >> 8) & 0x00FF; 
 //   unsigned char faible = freq & 0x00FF;  
 //Writing int variables en EEPROM 
EEPROM.write(0,(freq >> 8) & 0x00FF); // Poids fort
EEPROM.write(1,freq & 0x00FF); // Poids faibles
EEPROM.write(2,(sr >> 8) & 0x00FF); // Poids fort
EEPROM.write(3,sr&0x00FF);// Poids faibles
EEPROM.write(4,(pidv >> 8) & 0x00FF); // Poids fort
EEPROM.write(5,pidv&0x00FF);// Poids faibles
 //Writing byte variables en EEPROM
EEPROM.write(7,fec);
EEPROM.write(8,ip);
EEPROM.write(9,op);
EEPROM.write(10,0x55); // Special flag %01010101  "EEPROM is written"
}

//******************************* SUB LECTURE EEPROM *******************************
void eeread() //Lecture EEPROM   Val=EEPROM.read(addr);
{
unsigned char fort = EEPROM.read(0);     //récupère les 8 bits de gauche (poids forts) 
unsigned char faible = EEPROM.read(1); //récupère les 8 bits de droite (poids faibles) 
freq = fort ;         // recuperation PF
freq = freq << 8 ;     // rangement PF à leur place
freq = freq | faible ; // utilisation du masque 

sr=EEPROM.read(2); sr= sr <<8 ;  // Mise en place poids forts
sr = sr | EEPROM.read(3);// concat avec poids faibles
pidv=EEPROM.read(4); pidv= pidv <<8 ; 
pidv = pidv | EEPROM.read(5);
fec = EEPROM.read(7);
ip = EEPROM.read(8);
op = EEPROM.read(9);
rw = EEPROM.read(10);// flag "%01010101" to test if EEPROM is written
}

//************************************ Setup *********************************
void setup() {
  lcd.begin(16, 2); // two 16 characters lines
  lcd.display();
  analogWrite(10,255); //LCD Luminosity
  
  RpiSerial.begin(9600);// Serial to the Rpi
  Serial.begin (9600); //  Serial to the PC via Arduino "Serial Monitor"  at 9600
  delay(20);
  lcd.print("    RpiDATV     ");
  delay(50);
  lcd.setCursor(0,1);
  lcd.print(" Not Connected  "); 
  lcd.noCursor();delay(50);
  poscursor=2; line=0;page=0;login=0;loop1=0;

  freq=625;sr=500;fec=2;pidv=1001;ip=0;op=1; // modes par défaut
  
  rw = EEPROM.read(10); // Is it hex55  BIN1010101 ? EEPROM writed ?
  // Serial.print("rw="); Serial.print(rw,HEX);
  if (rw == 0x55){eeread();} // EEPROM read at start, if already written

  while (RpiSerial.read() > 0) delay(1); // clean serial buffer 
  
  loginRpi(); // Log by SSH to Rpi


 // End setup
}  

//*************************************Loop***********************************
void loop()
{
  if (login==1)lcd.setCursor(poscursor,line);          
  if (login==0)  // If not connected to Rpi
 {
  oldloop1=loop1;
  if (incomingByte=RpiSerial.available()>0) {   
      char byteIn = RpiSerial.read();
      cmd[cmdIndex] = byteIn;loop1=++loop1;
      Serial.print(byteIn);
      
        if(cmd[cmdIndex]=='V' && cmd[cmdIndex-1]=='T')  { //Détection de "TV"
        //command finished
        cmd[cmdIndex+1] = '\0'; 
        cmdIndex = 0;login=1;initRpi();
        Serial.println("\r\n **Connected by SSH to Rpi**"); 
        
        for (i=0;i<4;i++){
        lcd.setCursor(0,1); 
        lcd.print("                ");    
        delay(200); lcd.setCursor(0,1); 
        lcd.print("Connected to Rpi");delay(500);
         }
        printall();
        delay(200);      
        send2Rpi();// write config into rpidatvconfig.txt
        delay(200);
        RpiSerial.print (" sudo bash a.sh &>/dev/null \r\n ");
       
        }
      /*  else{Serial.println("Logoff");} */
        else cmdIndex=++cmdIndex; 
        }
       else if(cmdIndex++ >= MAX_CMD_LENGTH){ cmdIndex = 0;} 
  }

 lcd_key = read_LCD_buttons();  // read the buttons
 
 switch (lcd_key)               // Select action
 {  
   case btnRIGHT: //Droit
    poscursor=poscursor+1; // cursor to the right
     {
     if (page==0){
     if (poscursor==6 && line==0) {poscursor=7; line=0;}; //si curseur sur le point de frequence
     if (poscursor==8 && line==0) {poscursor=12; line=0;}; //si curseur sur le point de frequence
     if (poscursor==16 && line==0) {poscursor=4; line=1;}; //si curseur en butée ligne 0 à droite
     if (poscursor==5 && line==1 ) {poscursor=12; line=1;}; //si curseur sur le point de frequence
     if (poscursor==16 && line==1) {poscursor=3; line=0; page=1; printipop();}; //si curseur en butée ligne 1 à droite
     }    
     else if (page==1){
     if (poscursor==4 && line==0) {poscursor=3; line=1;}; //si curseur s
     if (poscursor==4 && line==1) {poscursor=2; line=0;page=0;printall();}; //si curseur en butée ligne 1 à droite ok
     }   
     Serial.print (" RIGHT Button\r\n");
     break;
     }
     
   case btnLEFT: //Gauche
     poscursor=poscursor-1; // décalage curseur
     {
     if(page==0){  
     if (poscursor==6 && line==0) {poscursor=5; line=0;}; 
     if (poscursor==11 && line==0) {poscursor=7; line=0;}; 
     if (poscursor==3 && line==1) {poscursor=15; line=0;}; //si curseur en butée ligne 1 à gauche
     if (poscursor==11 && line==1) {poscursor=4; line=1;}; 
     if (poscursor==1 && line==0) {poscursor=3; line=1;page=1;printipop();}; //si curseur en butée ligne 0 à gauche
     }
     else if(page==1){  
     if (poscursor==2 && line==1) {poscursor=3; line=0;};
     if (poscursor==2 && line==0) {poscursor=15; line=1;page=0;printall();}; //si curseur en butée ligne 0 à gauche  
     }
    
     Serial.print (" LEFT Button \r\n");
     break;
     }
     
   case btnUP: //Haut
     {
      if (page == 0 && line ==0)
      {                        // Frequency 
      oldfreq=freq;
      //Serial.print(oldfreq,DEC);
      if (poscursor==2) freq=freq+10000 ;
      if (poscursor==3) freq=freq+1000 ;
      if (poscursor==4) freq=freq+100 ;
      if (poscursor==5) freq=freq+10 ;
      if (poscursor==7) freq=freq+5 ;
      if (freq > 20000)freq=oldfreq;
      //Serial.print(freq,DEC);
      //Serial.print("  \r\n");
      printfreq();
      
      oldsr=sr;                 // SR
      if (poscursor==12) sr=sr+1000 ;
      if (poscursor==13) sr=sr+100 ;
      if (poscursor==14) sr=sr+10 ;
      if (poscursor==15) sr=sr+1 ;
      if (sr > 3000) sr=oldsr;
      printsr();
      }

      if (page==0 && line ==1)   // FEC
      {
      if (poscursor==4) fec=fec+1 ;
      if (fec==4) fec=5;
      if (fec==6) fec=7;
      if (fec > 7) fec=1;
      lcd.print(fec,DEC);

      oldpidv=pidv;             // PID video
      if (poscursor==12) pidv=pidv+1000 ;
      if (poscursor==13) pidv=pidv+100 ;
      if (poscursor==14) pidv=pidv+10 ;
      if (poscursor==15) pidv=pidv+1 ;
      if (pidv>9999) pidv=oldpidv;
      printpidv();
      }

      if (page==1 && line ==0){     // Input mode
       ip=++ip; 
      if (ip==7)ip=0; // Test last string
      printipop();}

       if (page==1 && line ==1){    // Output mode
       op=++op; 
      if (op==6)op=0; // test last string
      printipop();}
           
      Serial.print (" UP Button  \r\n");
     break;
     };

       case btnDOWN: //bas
     {
      if (page==0 && line==0)
      {
      oldfreq=freq;
      if (poscursor==2) freq=freq-10000 ;
      if (poscursor==3) freq=freq-1000 ;
      if (poscursor==4) freq=freq-100 ;
      if (poscursor==5) freq=freq-10 ;
      if (poscursor==7) freq=freq-5 ;
      if (freq < 625)freq=oldfreq;
      printfreq();
      oldsr=sr;
      if (poscursor==12) sr=sr-1000 ;
      if (poscursor==13) sr=sr-100 ;
      if (poscursor==14) sr=sr-10 ;
      if (poscursor==15) sr=sr-1 ;
      if (sr < 100) sr=oldsr;
      printsr();
      }

      if (page==0 && line==1)
      {
      if (poscursor==4) fec=fec-1 ;
      if (fec < 1) fec=7;
      if (fec==6) fec=5;
      if(fec==4) fec=3;
      lcd.print(fec,DEC);

      oldpidv=pidv;
      if (poscursor==12) pidv=pidv-1000 ;
      if (poscursor==13) pidv=pidv-100 ;
      if (poscursor==14) pidv=pidv-10 ;
      if (poscursor==15) pidv=pidv-1 ;
      if (pidv<100) pidv=oldpidv;
      printpidv();
      }    

     if (page==1 && line==0)
      {
      ip=--ip;
      if (ip== 255) ip=6;  // Test first ipString
      printipop();
      }    

      if (page==1 && line==1)   // Output mode 
      {
      op=--op;  // outputmode-1
      if (op== 255) op=5; // if mode <0 
      printipop();
      }    

     Serial.print (" DOWN Button  \r\n");
     break;
     };
     
   case btnSELECT:
     {
     Serial.print ("\r\n SELECT BUTTON  ");
     Serial.print ("\r\n Ecrit rpidatvconfig.txt  \r\n");
     send2Rpi();
     delay(200);
     RpiSerial.print (" sudo bash a.sh &>/dev/null \r\n ");
     if (page==0)printall();  // print freq, fec,sr,pidv
     if (page==1)printipop(); // print modes

    do {
    adc_key_in = analogRead(0);      // Test release button
    delay(1); timer++;        // timer inc toutes les 1 millisecondes
    if (timer >600) {Serial.write("MEMORISATION \r\n");timer=0; 
    eewrite();
    printmemo();
    delay(500);
    if (page==0)printall();
    if (page==1)printipop();
    }; // mesure tempo de 1 seconde environ  
    } while (adc_key_in < 900); // attente relachement
       
     break; 
    }
  }
   
   if ((login==0)&& (loop1==oldloop1)){loginRpi();loop1=0;} // re test de login
     
   do { adc_key_in = analogRead(0);      // Attente relachement touche
   delay(1); timer++; } while (adc_key_in < 900);
   timer=0; // raz timer

}

